// O kralovych truhliciach
// Autor: Peter Trebaticky
#include <stdio.h>

#define NOdebug

#define MAX 100

FILE *fin,*fout;
int poct,pock,poco;
int i,j,k;
int truhly[MAX][MAX];
int vraciamsa,odkial;

void hladaj(int co){
  int i;

  if((vraciamsa==0)&&(truhly[co][co]!=2)){
    truhly[co][co]=2;
    for(i=0;i<poct;i++)
      if((i!=co)&&(truhly[co][i]==1))hladaj(i);

    if(vraciamsa==1){
      if(co==odkial){
        vraciamsa=0;
        truhly[odkial][odkial]=0;
        hladaj(odkial);// este raz treba zistit, ci cez tento vrchol
                       // nejde iny cyklus
      } else{
          for(i=0;i<poct;i++){
            if(truhly[co][i]==1){
              truhly[co][i]=0;
              truhly[odkial][i]=1;
            }
            if(truhly[i][co]==1){
              truhly[i][co]=0;
              truhly[i][odkial]=1;
            }
          }
          truhly[odkial][odkial]=0;
        }
    } else truhly[co][co]=0;

  } if(co==odkial) vraciamsa=1;
}

void otvaraj(int co){
  int i;

  if(truhly[co][co]!=2){
    truhly[co][co]=2;
    for(i=0;i<poct;i++)
      if((i!=co)&&(truhly[co][i]==1))otvaraj(i);
  }
}

void main(void){
#ifdef debug
  fin=fopen("truhlica.in","rt");
  fout=fopen("truhlica.out","wt");
#else
  fin=stdin;
  fout=stdout;
#endif

  fscanf(fin,"%d %d",&poct,&pock);
  for(i=0;i<poct;i++){
    for(j=0;j<poct;j++)
      truhly[i][j]=0;
    truhly[i][i]=3;// ze v inej truhle nie je pre nu kluc
  }

  for(i=0;i<pock;i++){
    fscanf(fin,"%d %d",&j,&k);
    if(j!=k){
      truhly[j-1][k-1]=1;
      truhly[k-1][k-1]=0;
    }
  }

  poco=0;
  // najprv otvorime tie, pre ktore neexistuju kluce
  for(k=0;k<poct;k++){
    if(truhly[k][k]==3){otvaraj(k);poco++;}
  }

  // eliminujeme kazdy cyklus
  // pre vrchol 'odkial' zistime, ci cez neho ide nejaky cyklus
  // ak ano, nahradime cely cyklus vrcholom 'odkial'
  for(odkial=0;odkial<poct;odkial++){
    if(truhly[odkial][odkial]!=2){
      vraciamsa=0;
      hladaj(odkial);
    }
  }

  // zistime, do ktorych uzlov nevedie orientovana hrana
  for(i=0;i<poct;i++){
    if(truhly[i][i]!=2){
      truhly[i][i]=3;
      for(j=0;j<poct;j++)
        if(truhly[j][i]==1){
          truhly[i][i]=0;
          break;
        }
    }
  }

  // zasa otvorime truhlice, pre ktore neexistuju kluce
  for(k=0;k<poct;k++){
    if(truhly[k][k]==3){otvaraj(k);poco++;}
  }

  fprintf(fout,"%d\n",poco);

#ifdef debug
  fclose(fout);
  fclose(fin);
#endif
}